package cz.cvut.felk.cs.atg.securemessenger.commons;

import javax.net.ssl.KeyManager;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.TrustManagerFactory;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;

public class SecurityUtils {

    public static String readln() throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        return reader.readLine();
    }

    public static TrustManager[] getTrustManagers(String keyStore, char[] keyStorePasswd) throws KeyStoreException, IOException, NoSuchAlgorithmException, CertificateException {
        KeyStore ks = KeyStore.getInstance("JKS");
        try(FileInputStream stream = new FileInputStream(keyStore)){
            ks.load(stream, keyStorePasswd);
        }
        TrustManagerFactory kmf =
                TrustManagerFactory.getInstance("SunX509");
        kmf.init(ks);
        return kmf.getTrustManagers();
    }

    public static KeyManager[] getKeyManagers(String keyStore, char[] keyStorePasswd, char[] certPasswd) throws KeyStoreException, IOException, NoSuchAlgorithmException, CertificateException, UnrecoverableKeyException {
        KeyStore ks = KeyStore.getInstance("JKS");
        try(FileInputStream stream = new FileInputStream(keyStore)){
            ks.load(stream, keyStorePasswd);
        }
        KeyManagerFactory kmf =
                KeyManagerFactory.getInstance("SunX509");
        kmf.init(ks, certPasswd);
        return kmf.getKeyManagers();
    }
}
